/* Copyright (C) 2010-2021 Frankfurt Institute for Advanced Studies, Goethe-Universität Frankfurt, Frankfurt
   SPDX-License-Identifier: GPL-3.0-only
   Authors: Maksym Zyzak, Igor Kulakov [committer], Sergey Gorbunov */

/// \file CaDefines.h
/// \brief Macros for the CA tracking algorithm
/// \details Try to minimize the amount of macros. Try to call this header only from cxx files.

#pragma once  // include this header only once per compilation unit

#include <iostream>

#include <assert.h>

// #define CBMCA_DEBUG_MODE

#if defined(CBMCA_DEBUG_MODE)

#define CBMCA_DEBUG_ASSERT(v)                                                                                          \
  if (!(v)) {                                                                                                          \
    std::cerr << __FILE__ << ":" << __LINE__ << " assertion failed: " << #v << " = " << (v) << std::endl;              \
    assert(v);                                                                                                         \
  }
#else  // not CBMCA_DEBUG_MODE

#define CBMCA_DEBUG_ASSERT(v)

#endif  // CBMCA_DEBUG_MODE
